(benchmark maptest
 :logic AUFLIA

 :extrasorts (S T)

 :extrafuns  ((embed_S__Int S Int)
              (disembed_S__Int Int S))
 :assumption (forall (?x S)
                     (= (disembed_S__Int (embed_S__Int ?x)) ?x)
                     :pat { (embed_S__Int ?x) })

 :extrafuns  ((embed_T__Int T Int)
              (disembed_T__Int Int T))
 :assumption (forall (?x T)
                     (= (disembed_T__Int (embed_T__Int ?x)) ?x)
                     :pat { (embed_T__Int ?x) })

;; Maps are partial, so that we need a value distinguishing undefinedness

 :extrafuns ((Map_undefined Int))

 :assumption (forall (?x S)
                     (not (= (embed_S__Int ?x) Map_undefined))
              :pat { (embed_S__Int ?x) } )

 :assumption (forall (?x T)
                     (not (= (embed_T__Int ?x) Map_undefined))
              :pat { (embed_T__Int ?x) } )

;; Set axioms

 :extrasorts (Set_T Set_S)

 :extrafuns  ((embed_Set_S__Array Set_S Array)
              (disembed_Set_S__Array Array Set_S))
 :assumption (forall (?x Set_S)
                     (= (disembed_Set_S__Array (embed_Set_S__Array ?x)) ?x)
                     :pat { (embed_Set_S__Array ?x) })

 :extrafuns  ((embed_Set_T__Array Set_T Array)
              (disembed_Set_T__Array Array Set_T))
 :assumption (forall (?x Set_T)
                     (= (disembed_Set_T__Array (embed_Set_T__Array ?x)) ?x)
                     :pat { (embed_Set_T__Array ?x) })

 :extrafuns  ((Set_elem Int)
              (Set_nonelem Int))
 :assumption (not (= Set_elem Set_nonelem))

 :assumption (forall (?x Set_S) (?y Int)
                     (or (= (select (embed_Set_S__Array ?x) ?y) Set_elem)
                         (= (select (embed_Set_S__Array ?x) ?y) Set_nonelem))
                     :pat { (select (embed_Set_S__Array ?x) ?y) })

 :assumption (forall (?x Set_T) (?y Int)
                     (or (= (select (embed_Set_T__Array ?x) ?y) Set_elem)
                         (= (select (embed_Set_T__Array ?x) ?y) Set_nonelem))
                     :pat { (select (embed_Set_T__Array ?x) ?y) })

 :extrapreds ((in_Set_S S Set_S))
 :assumption (forall (?x S) (?y Set_S)
                     (iff (in_Set_S ?x ?y)
                          (= (select (embed_Set_S__Array ?y)
                                     (embed_S__Int ?x))
                             Set_elem))
                     :pat { (in_Set_S ?x ?y) } )

 :extrapreds ((in_Set_T T Set_T))
 :assumption (forall (?x T) (?y Set_T)
                     (iff (in_Set_T ?x ?y)
                          (= (select (embed_Set_T__Array ?y)
                                     (embed_T__Int ?x))
                             Set_elem))
                     :pat { (in_Set_T ?x ?y) } )

;; Empty sets

 :extrapreds ((isEmpty_Set_S Set_S))
 :assumption (forall (?x Set_S)
                     (iff (isEmpty_Set_S ?x)
                          (forall (?y Int)
                                  (= (select (embed_Set_S__Array ?x) ?y) Set_nonelem)))
              :pat { (isEmpty_Set_S ?x) } )

 :extrafuns ((emptySet_Set_S Set_S))
 :assumption (isEmpty_Set_S emptySet_Set_S)

 :extrapreds ((isEmpty_Set_T Set_T))
 :assumption (forall (?x Set_T)
                     (iff (isEmpty_Set_T ?x)
                          (forall (?y Int)
                                  (= (select (embed_Set_T__Array ?x) ?y) Set_nonelem)))
              :pat { (isEmpty_Set_T ?x) } )

 :extrafuns ((emptySet_Set_T Set_T))
 :assumption (isEmpty_Set_T emptySet_Set_T)

 :extrafuns ((insert_Set_S S Set_S Set_S))
 :assumption (forall (?x S) (?y Set_S)
                     (= (embed_Set_S__Array (insert_Set_S ?x ?y))
                        (store (embed_Set_S__Array ?y)
                               (embed_S__Int ?x) Set_elem))
                     :pat { (insert_Set_S ?x ?y) } )

 :extrafuns ((insert_Set_T T Set_T Set_T))
 :assumption (forall (?x T) (?y Set_T)
                     (= (embed_Set_T__Array (insert_Set_T ?x ?y))
                        (store (embed_Set_T__Array ?y)
                               (embed_T__Int ?x) Set_elem))
                     :pat { (insert_Set_T ?x ?y) } )

;; Intersection of sets

 :extrafuns ((inter_Set_S Set_S Set_S Set_S))
 :assumption (forall (?x Int) (?y Set_S) (?z Set_S)
                     (iff (= (select (embed_Set_S__Array (inter_Set_S ?y ?z)) ?x)
                             Set_elem)
                          (and (= (select (embed_Set_S__Array ?y) ?x) Set_elem)
                               (= (select (embed_Set_S__Array ?z) ?x) Set_elem)))
                     :pat { (select (embed_Set_S__Array (inter_Set_S ?y ?z)) ?x) } )

;; Difference of sets

 :extrafuns ((setminus_Set_S Set_S Set_S Set_S))
 :assumption (forall (?x Int) (?y Set_S) (?z Set_S)
                     (iff (= (select (embed_Set_S__Array (setminus_Set_S ?y ?z)) ?x)
                             Set_elem)
                          (and (= (select (embed_Set_S__Array ?y) ?x) Set_elem)
                               (= (select (embed_Set_S__Array ?z) ?x) Set_nonelem)))
                     :pat { (select (embed_Set_S__Array (setminus_Set_S ?y ?z)) ?x) } )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Map stuff

 :extrasorts (Map_S_T)

;; The map domain

 :extrafuns ((domain_Map_S_T Map_S_T Set_S))

;; Map application

 :extrafuns ((apply_Map_S_T Map_S_T S T))

;; Empty maps

 :extrafuns ((emptyMap_Map_S_T Map_S_T))

 :assumption (= (domain_Map_S_T emptyMap_Map_S_T) emptySet_Set_S)

;; Map overwriting

 :extrafuns ((overwrite_Map_S_T Map_S_T S T Map_S_T))

 :assumption (forall (?x Map_S_T) (?y S) (?z T)
                     (= (apply_Map_S_T (overwrite_Map_S_T ?x ?y ?z) ?y) ?z)
              :pat { (overwrite_Map_S_T ?x ?y ?z) } )

 :assumption (forall (?x Map_S_T) (?y1 S) (?y2 S) (?z T)
                     (or (= ?y1 ?y2)
                         (not (in_Set_S ?y2 (domain_Map_S_T ?x)))
                         (= (apply_Map_S_T (overwrite_Map_S_T ?x ?y1 ?z) ?y2)
                            (apply_Map_S_T ?x ?y2)))
              :pat { (apply_Map_S_T (overwrite_Map_S_T ?x ?y1 ?z) ?y2) } )

 :assumption (forall (?x Map_S_T) (?y S) (?z T)
                     (= (domain_Map_S_T (overwrite_Map_S_T ?x ?y ?z))
                        (insert_Set_S ?y (domain_Map_S_T ?x)))
              :pat { (domain_Map_S_T (overwrite_Map_S_T ?x ?y ?z)) } )

;; Extensionality

 :extrapreds ((equals_Map_S_T Map_S_T Map_S_T))
 :assumption (forall (?x Map_S_T) (?y Map_S_T)
               (iff (equals_Map_S_T ?x ?y)
                    (and (= (domain_Map_S_T ?x) (domain_Map_S_T ?y))
                         (forall (?z S)
                                 (implies (in_Set_S ?z (domain_Map_S_T ?x))
                                          (= (apply_Map_S_T ?x ?z)
                                             (apply_Map_S_T ?y ?z))))))
              :pat { (equals_Map_S_T ?x ?y) } )

 :assumption (forall (?x Map_S_T) (?y Map_S_T)
                     (iff (= ?x ?y) (equals_Map_S_T ?x ?y)))

;; The map range

 :extrafuns ((range_Map_S_T Map_S_T Set_T))

 :assumption (= (range_Map_S_T emptyMap_Map_S_T) emptySet_Set_T)

 :assumption (forall (?x Map_S_T) (?y S) (?z T)
                     (= (range_Map_S_T (overwrite_Map_S_T ?x ?y ?z))
                        (insert_Set_T ?z (range_Map_S_T ?x)))
              :pat { (range_Map_S_T (overwrite_Map_S_T ?x ?y ?z)) } )

;; Restriction of the domain of maps

 :extrafuns ((restrict_Map_S_T Map_S_T Set_S Map_S_T))

 :assumption (forall (?x Map_S_T) (?y Set_S)
                     (= (domain_Map_S_T (restrict_Map_S_T ?x ?y))
                        (inter_Set_S (domain_Map_S_T ?x) ?y))
              :pat { (restrict_Map_S_T ?x ?y) } )

 :assumption (forall (?x Map_S_T) (?y Set_S) (?z S)
                     (implies (and (in_Set_S ?z (domain_Map_S_T ?x))
                                   (in_Set_S ?z ?y))
                              (= (apply_Map_S_T (restrict_Map_S_T ?x ?y) ?z)
                                 (apply_Map_S_T ?x ?z)))
              :pat { (apply_Map_S_T (restrict_Map_S_T ?x ?y) ?z) } )

;; Subtraction of the domain of maps

 :extrafuns ((subtract_Map_S_T Map_S_T Set_S Map_S_T))

 :assumption (forall (?x Map_S_T) (?y Set_S)
                     (= (domain_Map_S_T (subtract_Map_S_T ?x ?y))
                        (setminus_Set_S (domain_Map_S_T ?x) ?y))
              :pat { (subtract_Map_S_T ?x ?y) } )

 :assumption (forall (?x Map_S_T) (?y Set_S) (?z S)
                     (implies (and (in_Set_S ?z (domain_Map_S_T ?x))
                                   (not (in_Set_S ?z ?y)))
                              (= (apply_Map_S_T (subtract_Map_S_T ?x ?y) ?z)
                                 (apply_Map_S_T ?x ?z)))
              :pat { (apply_Map_S_T (subtract_Map_S_T ?x ?y) ?z) } )

;; Some examples

 :extrafuns ((xx S) (bb S) (yy T) (zz T) (aa T) (m Map_S_T) (s Set_T))

 :formula (not (and
   (= (apply_Map_S_T (overwrite_Map_S_T m xx yy) xx) yy)
   (in_Set_S xx (domain_Map_S_T (overwrite_Map_S_T m xx yy)))
   (equals_Map_S_T (overwrite_Map_S_T m xx yy)
                   (overwrite_Map_S_T (overwrite_Map_S_T m xx yy) xx yy))
   (in_Set_T yy (range_Map_S_T (overwrite_Map_S_T m xx yy)))

   (not (in_Set_T yy (range_Map_S_T emptyMap_Map_S_T)))
   (not (in_Set_S xx (domain_Map_S_T emptyMap_Map_S_T)))
 ))
)