(benchmark settest
 :logic AUFLIA

 :extrasorts (T Set_T)

 :extrafuns  ((Set_elem Int)
              (Set_nonelem Int))
 :assumption (not (= Set_elem Set_nonelem))

 :extrafuns  ((embed_Set_T__Array Set_T Array)
              (disembed_Set_T__Array Array Set_T))
 :assumption (forall (?x Set_T)
                     (= (disembed_Set_T__Array (embed_Set_T__Array ?x)) ?x)
                     :pat { (embed_Set_T__Array ?x) })

 :assumption (forall (?x Set_T) (?y Int)
                     (or (= (select (embed_Set_T__Array ?x) ?y) Set_elem)
                         (= (select (embed_Set_T__Array ?x) ?y) Set_nonelem))
                     :pat { (select (embed_Set_T__Array ?x) ?y) })

 :extrafuns  ((embed_T__Int T Int)
              (disembed_T__Int Int T))
 :assumption (forall (?x T)
                     (= (disembed_T__Int (embed_T__Int ?x)) ?x)
                     :pat { (embed_T__Int ?x) })

;; Empty sets

 :extrapreds ((isEmpty_Set_T Set_T))
 :assumption (forall (?x Set_T)
                     (iff (isEmpty_Set_T ?x)
                          (forall (?y Int)
                                  (= (select (embed_Set_T__Array ?x) ?y) Set_nonelem)))
              :pat { (isEmpty_Set_T ?x) } )

 :extrafuns ((emptySet_Set_T Set_T))
 :assumption (isEmpty_Set_T emptySet_Set_T)

;; Set insertion

 :extrafuns ((insert_Set_T T Set_T Set_T))
 :assumption (forall (?x T) (?y Set_T)
                     (= (embed_Set_T__Array (insert_Set_T ?x ?y))
                        (store (embed_Set_T__Array ?y)
                               (embed_T__Int ?x) Set_elem))
                     :pat { (insert_Set_T ?x ?y) } )

;; Set membership predicate

 :extrapreds ((in_Set_T T Set_T))
 :assumption (forall (?x T) (?y Set_T)
                     (iff (in_Set_T ?x ?y)
                          (= (select (embed_Set_T__Array ?y)
                                     (embed_T__Int ?x))
                             Set_elem))
                     :pat { (in_Set_T ?x ?y) } )

;; Subset relation

 :extrapreds ((subset_Set_T Set_T Set_T))
 :assumption (forall (?x Set_T) (?y Set_T)
                     (iff (subset_Set_T ?x ?y)
                          (forall (?z Int)
                                  (implies (= (select (embed_Set_T__Array ?x) ?z)
                                              Set_elem)
                                           (= (select (embed_Set_T__Array ?y) ?z)
                                              Set_elem))))
                     :pat { (subset_Set_T ?x ?y) } )

;; Union of sets

 :extrafuns ((union_Set_T Set_T Set_T Set_T))
 :assumption (forall (?x Int) (?y Set_T) (?z Set_T)
                     (iff (= (select (embed_Set_T__Array (union_Set_T ?y ?z)) ?x)
                             Set_elem)
                          (or (= (select (embed_Set_T__Array ?y) ?x) Set_elem)
                              (= (select (embed_Set_T__Array ?z) ?x) Set_elem)))
                     :pat { (select (embed_Set_T__Array (union_Set_T ?y ?z)) ?x) } )

 :assumption (= (union_Set_T emptySet_Set_T emptySet_Set_T)
                emptySet_Set_T)

;; Intersection of sets

 :extrafuns ((inter_Set_T Set_T Set_T Set_T))
 :assumption (forall (?x Int) (?y Set_T) (?z Set_T)
                     (iff (= (select (embed_Set_T__Array (inter_Set_T ?y ?z)) ?x)
                             Set_elem)
                          (and (= (select (embed_Set_T__Array ?y) ?x) Set_elem)
                               (= (select (embed_Set_T__Array ?z) ?x) Set_elem)))
                     :pat { (select (embed_Set_T__Array (inter_Set_T ?y ?z)) ?x) } )

;; Difference of sets

 :extrafuns ((setminus_Set_T Set_T Set_T Set_T))
 :assumption (forall (?x Int) (?y Set_T) (?z Set_T)
                     (iff (= (select (embed_Set_T__Array (setminus_Set_T ?y ?z)) ?x)
                             Set_elem)
                          (and (= (select (embed_Set_T__Array ?y) ?x) Set_elem)
                               (= (select (embed_Set_T__Array ?z) ?x) Set_nonelem)))
                     :pat { (select (embed_Set_T__Array (setminus_Set_T ?y ?z)) ?x) } )

;; Cardinality of sets, with various rules how to derive cardinalities

 :extrafuns ((card_Set_T Set_T Int))

 :assumption (= (card_Set_T emptySet_Set_T) 0)

 :assumption (forall (?x Set_T) (>= (card_Set_T ?x) 0)
              :pat { (card_Set_T ?x) } )

 :assumption (forall (?x T) (?y Set_T)
                     (= (card_Set_T (insert_Set_T ?x ?y))
                        (ite (in_Set_T ?x ?y) (card_Set_T ?y)
                                              (+ (card_Set_T ?y) 1)))
              :pat { (card_Set_T (insert_Set_T ?x ?y)) } )

 :assumption (forall (?x Set_T) (?y Set_T)
                     (implies (subset_Set_T ?x ?y)
                              (<= (card_Set_T ?x) (card_Set_T ?y)))
              :pat { (subset_Set_T ?x ?y) } )

 :assumption (forall (?x Set_T) (?y Set_T)
                     (= (card_Set_T (union_Set_T ?x ?y))
                        (- (+ (card_Set_T ?x) (card_Set_T ?y))
                           (card_Set_T (inter_Set_T ?x ?y)))))

 :assumption (forall (?x T) (?y Set_T) (?z Set_T)
                     (= (union_Set_T (insert_Set_T ?x ?y) ?z)
                        (insert_Set_T ?x (union_Set_T ?y ?z)))
              :pat { (card_Set_T (union_Set_T (insert_Set_T ?x ?y) ?z)) } )

 :assumption (forall (?x T) (?y Set_T) (?z Set_T)
                     (= (union_Set_T ?z (insert_Set_T ?x ?y))
                        (insert_Set_T ?x (union_Set_T ?z ?y)))
              :pat { (card_Set_T (union_Set_T ?z (insert_Set_T ?x ?y))) } )

 :assumption (forall (?x Set_T) (?y Set_T)
                     (= (card_Set_T (setminus_Set_T ?x ?y))
                        (- (card_Set_T ?x) (card_Set_T (inter_Set_T ?x ?y))))
              : pat { (card_Set_T (setminus_Set_T ?x ?y)) })



;; Some examples

 :extrafuns ((xx T) (yy T) (s Set_T))

 :formula (not
     (and
       (in_Set_T xx (insert_Set_T xx emptySet_Set_T))
       (implies (in_Set_T yy s) (in_Set_T yy (insert_Set_T xx s)))
       (in_Set_T xx
          (union_Set_T (insert_Set_T xx emptySet_Set_T)
                       (insert_Set_T yy emptySet_Set_T)))
       (forall (?x Set_T) (subset_Set_T emptySet_Set_T ?x))
       (forall (?x Set_T) (?y Set_T) (subset_Set_T ?x (union_Set_T ?x ?y)))
       (forall (?x Set_T) (not (in_Set_T xx
                            (setminus_Set_T ?x (insert_Set_T xx emptySet_Set_T)))))
       (= (insert_Set_T xx (insert_Set_T yy emptySet_Set_T))
          (insert_Set_T yy (insert_Set_T xx emptySet_Set_T)))
       (= (union_Set_T (insert_Set_T xx emptySet_Set_T)
                                            (insert_Set_T yy emptySet_Set_T))
          (insert_Set_T xx (insert_Set_T yy emptySet_Set_T)))

;; this cannot be handled. maybe the translation should generate formulae
;; with the predicate isEmpty instead (as a heuristic)
;;       (forall (?x Set_T) (= emptySet_Set_T (setminus_Set_T ?x ?x)))
       (forall (?x Set_T) (isEmpty_Set_T (setminus_Set_T ?x ?x)))
       (implies (not (= xx yy))
                (= (card_Set_T (insert_Set_T xx (insert_Set_T yy emptySet_Set_T))) 2))
       (<= (card_Set_T (insert_Set_T xx (insert_Set_T yy emptySet_Set_T))) 2)
       (implies (not (= xx yy))
                (= (card_Set_T (union_Set_T (insert_Set_T xx emptySet_Set_T)
                                            (insert_Set_T yy emptySet_Set_T))) 2))
       (= (card_Set_T (insert_Set_T xx (insert_Set_T xx emptySet_Set_T))) 1)
       (implies (not (= xx yy))
                (= (card_Set_T (inter_Set_T (insert_Set_T xx emptySet_Set_T)
                                            (insert_Set_T yy emptySet_Set_T))) 0))
       (= (card_Set_T (setminus_Set_T (insert_Set_T xx emptySet_Set_T)
                                      (insert_Set_T xx emptySet_Set_T))) 0)
       (implies (not (= xx yy))
                (= (card_Set_T (setminus_Set_T (insert_Set_T yy emptySet_Set_T)
                                               (insert_Set_T xx emptySet_Set_T))) 1))
     )
 )
)